// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.

#line 37 "parser/parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "parser/parser.hh"

// User implementation prologue.

#line 51 "parser/parser.cc" // lalr1.cc:412
// Unqualified %code blocks.
#line 46 "parser/parser.yy" // lalr1.cc:413

	#include "Driver.h"
	// Prototype for the yylex function
	static int yylex(parser::Parser::semantic_type * yylval, parser::Parser::location_type* yylloc, parser::FlexScanner &scanner);

#line 59 "parser/parser.cc" // lalr1.cc:413


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "parser/parser.yy" // lalr1.cc:479
namespace parser {
#line 145 "parser/parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Parser::Parser (parser::Driver& driver_yyarg, parser::FlexScanner& scanner_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg),
      scanner (scanner_yyarg)
  {}

  Parser::~Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  Parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
    value = other.value;
  }


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  inline
  Parser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::clear ()
  {
    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  Parser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
    value = s.value;
    location = s.location;
  }

  // by_type.
  inline
  Parser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  Parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  Parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  Parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  Parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  Parser::by_type::type_get () const
  {
    return type;
  }


  // by_state.
  inline
  Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Parser::symbol_number_type
  Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
    value = that.value;
    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YYUSE (yysym.type_get ());
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, scanner));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 139 "parser/parser.yy" // lalr1.cc:859
    { driver.program = (yystack_[0].value.program); }
#line 626 "parser/parser.cc" // lalr1.cc:859
    break;

  case 3:
#line 142 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.program) = new Program(); }
#line 632 "parser/parser.cc" // lalr1.cc:859
    break;

  case 4:
#line 143 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.program) = (yystack_[1].value.program); (yylhs.value.program)->statements->push_back((yystack_[0].value.statement)); }
#line 638 "parser/parser.cc" // lalr1.cc:859
    break;

  case 5:
#line 144 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.program) = (yystack_[1].value.program); (yylhs.value.program)->metastatements->push_back((yystack_[0].value.string)); }
#line 644 "parser/parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 154 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new Rule(new Disjunction(new vector<ClassicalLiteral*>()), new Body(new vector<BodyElement*>())); }
#line 650 "parser/parser.cc" // lalr1.cc:859
    break;

  case 7:
#line 155 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new Rule(new Disjunction(new vector<ClassicalLiteral*>()), new Body((yystack_[1].value.bodyElements))); }
#line 656 "parser/parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 156 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new Rule((yystack_[1].value.head), new Body(new vector<BodyElement*>())); }
#line 662 "parser/parser.cc" // lalr1.cc:859
    break;

  case 9:
#line 157 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new Rule((yystack_[2].value.head), new Body(new vector<BodyElement*>())); }
#line 668 "parser/parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 158 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new Rule((yystack_[3].value.head), new Body((yystack_[1].value.bodyElements))); }
#line 674 "parser/parser.cc" // lalr1.cc:859
    break;

  case 11:
#line 159 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new WeakConstraint(new Body(new vector<BodyElement*>()), (yystack_[1].value.weightAtLevel)); }
#line 680 "parser/parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 160 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = new WeakConstraint(new Body((yystack_[4].value.bodyElements)), (yystack_[1].value.weightAtLevel)); }
#line 686 "parser/parser.cc" // lalr1.cc:859
    break;

  case 13:
#line 161 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.statement) = (yystack_[1].value.optimize); }
#line 692 "parser/parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 164 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.head) = new Disjunction((yystack_[0].value.classicalLiterals)); }
#line 698 "parser/parser.cc" // lalr1.cc:859
    break;

  case 15:
#line 165 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.head)=(yystack_[0].value.head); }
#line 704 "parser/parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 168 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.bodyElements) = new vector<BodyElement*>(); (yylhs.value.bodyElements)->push_back((yystack_[0].value.bodyElement)); }
#line 710 "parser/parser.cc" // lalr1.cc:859
    break;

  case 17:
#line 169 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.bodyElements)=(yystack_[2].value.bodyElements); (yylhs.value.bodyElements)->push_back((yystack_[0].value.bodyElement)); }
#line 716 "parser/parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 172 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.bodyElement) = (yystack_[0].value.nafLiteral); }
#line 722 "parser/parser.cc" // lalr1.cc:859
    break;

  case 19:
#line 173 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.bodyElement) = (yystack_[0].value.aggregate); }
#line 728 "parser/parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 174 "parser/parser.yy" // lalr1.cc:859
    { (yystack_[0].value.aggregate)->nafNegated=true; (yylhs.value.bodyElement) = (yystack_[0].value.aggregate); }
#line 734 "parser/parser.cc" // lalr1.cc:859
    break;

  case 21:
#line 177 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.classicalLiterals) = new vector<ClassicalLiteral *>(); (yylhs.value.classicalLiterals)->push_back((yystack_[0].value.classicalLiteral)); }
#line 740 "parser/parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 178 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.classicalLiterals)=(yystack_[2].value.classicalLiterals); (yylhs.value.classicalLiterals)->push_back((yystack_[0].value.classicalLiteral)); }
#line 746 "parser/parser.cc" // lalr1.cc:859
    break;

  case 23:
#line 182 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.head) = new Choice((yystack_[0].value.choiceElements)); }
#line 752 "parser/parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 183 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.head) = new Choice((yystack_[0].value.choiceElements), new Guard((yystack_[1].value.string), (yystack_[2].value.term), true)); }
#line 758 "parser/parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 184 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.head) = new Choice((yystack_[2].value.choiceElements), new Guard((yystack_[1].value.string), (yystack_[0].value.term), false)); }
#line 764 "parser/parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 185 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.head) = new Choice((yystack_[2].value.choiceElements), new Guard((yystack_[3].value.string), (yystack_[4].value.term), true), new Guard((yystack_[1].value.string), (yystack_[0].value.term), false)); }
#line 770 "parser/parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 188 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElements) = new vector<ChoiceElement *>(); }
#line 776 "parser/parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 189 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElements)=(yystack_[1].value.choiceElements); }
#line 782 "parser/parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 191 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElements) = new vector<ChoiceElement *>(); (yylhs.value.choiceElements)->push_back((yystack_[0].value.choiceElement)); }
#line 788 "parser/parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 192 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElements)=(yystack_[2].value.choiceElements); (yylhs.value.choiceElements)->push_back((yystack_[0].value.choiceElement)); }
#line 794 "parser/parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 195 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElement) = new ChoiceElement((yystack_[0].value.classicalLiteral), new LiteralBody()); }
#line 800 "parser/parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 196 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElement) = new ChoiceElement((yystack_[1].value.classicalLiteral), new LiteralBody()); }
#line 806 "parser/parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 197 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.choiceElement) = new ChoiceElement((yystack_[2].value.classicalLiteral), new LiteralBody((yystack_[0].value.nafLiterals))); }
#line 812 "parser/parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 200 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregate) = (yystack_[0].value.aggregate); }
#line 818 "parser/parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 201 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregate) = (yystack_[0].value.aggregate); (yylhs.value.aggregate)->guard_l = new Guard((yystack_[1].value.string), (yystack_[2].value.term), true); }
#line 824 "parser/parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 202 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregate) = (yystack_[2].value.aggregate); (yylhs.value.aggregate)->guard_r = new Guard((yystack_[1].value.string), (yystack_[0].value.term), false); }
#line 830 "parser/parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 203 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregate) = (yystack_[2].value.aggregate); (yylhs.value.aggregate)->guard_l = new Guard((yystack_[3].value.string), (yystack_[4].value.term), true); (yylhs.value.aggregate)->guard_r = new Guard((yystack_[1].value.string), (yystack_[0].value.term), false); }
#line 836 "parser/parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 206 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregate) = new Aggregate((yystack_[3].value.string), false, (yystack_[1].value.aggregateElements)); }
#line 842 "parser/parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 209 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElements) = new vector<AggregateElement *>(); (yylhs.value.aggregateElements)->push_back((yystack_[0].value.aggregateElement)); }
#line 848 "parser/parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 210 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElements)=(yystack_[2].value.aggregateElements); (yylhs.value.aggregateElements)->push_back((yystack_[0].value.aggregateElement)); }
#line 854 "parser/parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 213 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElement) = new AggregateElement(new TermTuple(new vector<Term*>())); }
#line 860 "parser/parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 214 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElement) = new AggregateElement(new TermTuple((yystack_[0].value.terms))); }
#line 866 "parser/parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 215 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElement) = new AggregateElement(new TermTuple((yystack_[1].value.terms))); }
#line 872 "parser/parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 216 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElement) = new AggregateElement(new TermTuple((yystack_[2].value.terms)), new LiteralBody((yystack_[0].value.nafLiterals))); }
#line 878 "parser/parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 217 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElement) = new AggregateElement(new TermTuple(new vector<Term*>())); }
#line 884 "parser/parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 218 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.aggregateElement) = new AggregateElement(new LiteralBody((yystack_[0].value.nafLiterals))); }
#line 890 "parser/parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 221 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("#count"); }
#line 896 "parser/parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 222 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("#max"); }
#line 902 "parser/parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 223 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("#min"); }
#line 908 "parser/parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 224 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("#sum"); }
#line 914 "parser/parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 227 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimize) = new OptimizeStatement((yystack_[2].value.string), new vector<OptimizeElement *>()); }
#line 920 "parser/parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 228 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimize) = new OptimizeStatement((yystack_[3].value.string), (yystack_[1].value.optimizeElements)); }
#line 926 "parser/parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 231 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimizeElements) = new vector<OptimizeElement *>(); (yylhs.value.optimizeElements)->push_back((yystack_[0].value.optimizeElement)); }
#line 932 "parser/parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 232 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimizeElements)=(yystack_[2].value.optimizeElements); (yylhs.value.optimizeElements)->push_back((yystack_[0].value.optimizeElement)); }
#line 938 "parser/parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 235 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimizeElement) = new OptimizeElement((yystack_[0].value.weightAtLevel), new LiteralBody()); }
#line 944 "parser/parser.cc" // lalr1.cc:859
    break;

  case 56:
#line 236 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimizeElement) = new OptimizeElement((yystack_[1].value.weightAtLevel), new LiteralBody()); }
#line 950 "parser/parser.cc" // lalr1.cc:859
    break;

  case 57:
#line 237 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.optimizeElement) = new OptimizeElement((yystack_[2].value.weightAtLevel), new LiteralBody((yystack_[0].value.nafLiterals))); }
#line 956 "parser/parser.cc" // lalr1.cc:859
    break;

  case 58:
#line 240 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("#minimize"); }
#line 962 "parser/parser.cc" // lalr1.cc:859
    break;

  case 59:
#line 241 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("#maximize"); }
#line 968 "parser/parser.cc" // lalr1.cc:859
    break;

  case 60:
#line 244 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.weightAtLevel) = new WeightAtLevel((yystack_[0].value.term)); }
#line 974 "parser/parser.cc" // lalr1.cc:859
    break;

  case 61:
#line 245 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.weightAtLevel) = new WeightAtLevel((yystack_[2].value.term), (yystack_[0].value.term)); }
#line 980 "parser/parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 246 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.weightAtLevel) = new WeightAtLevel((yystack_[2].value.term), new TermTuple((yystack_[0].value.terms))); }
#line 986 "parser/parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 247 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.weightAtLevel) = new WeightAtLevel((yystack_[4].value.term), (yystack_[2].value.term), new TermTuple((yystack_[0].value.terms))); }
#line 992 "parser/parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 250 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nafLiterals) = new vector<NafLiteral*>(); (yylhs.value.nafLiterals)->push_back((yystack_[0].value.nafLiteral)); }
#line 998 "parser/parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 251 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nafLiterals)=(yystack_[2].value.nafLiterals); (yylhs.value.nafLiterals)->push_back((yystack_[0].value.nafLiteral)); }
#line 1004 "parser/parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 254 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nafLiteral) = (yystack_[0].value.classicalLiteral); }
#line 1010 "parser/parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 255 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nafLiteral) = (yystack_[0].value.nafLiteral); }
#line 1016 "parser/parser.cc" // lalr1.cc:859
    break;

  case 68:
#line 256 "parser/parser.yy" // lalr1.cc:859
    { (yystack_[0].value.classicalLiteral)->nafNegated=true; (yylhs.value.nafLiteral) = (yystack_[0].value.classicalLiteral);}
#line 1022 "parser/parser.cc" // lalr1.cc:859
    break;

  case 69:
#line 259 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.classicalLiteral) = new ClassicalLiteral((yystack_[0].value.nameTuplesP)->first, false, false, (yystack_[0].value.nameTuplesP)->second); delete (yystack_[0].value.nameTuplesP); }
#line 1028 "parser/parser.cc" // lalr1.cc:859
    break;

  case 70:
#line 260 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.classicalLiteral) = new ClassicalLiteral((yystack_[0].value.nameTuplesP)->first, true, false, (yystack_[0].value.nameTuplesP)->second); delete (yystack_[0].value.nameTuplesP); }
#line 1034 "parser/parser.cc" // lalr1.cc:859
    break;

  case 71:
#line 263 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nameTuplesP) = new pair<std::string*, TermTuples*>((yystack_[0].value.string), NULL); }
#line 1040 "parser/parser.cc" // lalr1.cc:859
    break;

  case 72:
#line 264 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nameTuplesP) = new pair<std::string*, TermTuples*>((yystack_[2].value.string), NULL); }
#line 1046 "parser/parser.cc" // lalr1.cc:859
    break;

  case 73:
#line 265 "parser/parser.yy" // lalr1.cc:859
    { { (yylhs.value.nameTuplesP) = new pair<std::string*, TermTuples*>((yystack_[3].value.string), new TermTuples((yystack_[1].value.termTuples))); } }
#line 1052 "parser/parser.cc" // lalr1.cc:859
    break;

  case 74:
#line 268 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.termTuples) = new vector<TermTuple *>(); (yylhs.value.termTuples)->push_back(new TermTuple((yystack_[0].value.terms))); }
#line 1058 "parser/parser.cc" // lalr1.cc:859
    break;

  case 75:
#line 269 "parser/parser.yy" // lalr1.cc:859
    {(yystack_[2].value.termTuples)->push_back(new TermTuple((yystack_[0].value.terms))); (yylhs.value.termTuples)=(yystack_[2].value.termTuples); }
#line 1064 "parser/parser.cc" // lalr1.cc:859
    break;

  case 76:
#line 272 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.nafLiteral) = new BuiltinAtom((yystack_[2].value.term), (yystack_[1].value.string), (yystack_[0].value.term)); }
#line 1070 "parser/parser.cc" // lalr1.cc:859
    break;

  case 77:
#line 276 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("="); }
#line 1076 "parser/parser.cc" // lalr1.cc:859
    break;

  case 78:
#line 277 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("!="); }
#line 1082 "parser/parser.cc" // lalr1.cc:859
    break;

  case 79:
#line 278 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("<"); }
#line 1088 "parser/parser.cc" // lalr1.cc:859
    break;

  case 80:
#line 279 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string(">"); }
#line 1094 "parser/parser.cc" // lalr1.cc:859
    break;

  case 81:
#line 280 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string("<="); }
#line 1100 "parser/parser.cc" // lalr1.cc:859
    break;

  case 82:
#line 281 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.string) = new std::string(">="); }
#line 1106 "parser/parser.cc" // lalr1.cc:859
    break;

  case 83:
#line 284 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.terms) = new vector<Term *>(); (yylhs.value.terms)->push_back((yystack_[0].value.term)); }
#line 1112 "parser/parser.cc" // lalr1.cc:859
    break;

  case 84:
#line 285 "parser/parser.yy" // lalr1.cc:859
    { (yystack_[2].value.terms)->push_back((yystack_[0].value.term)); (yylhs.value.terms)=(yystack_[2].value.terms); }
#line 1118 "parser/parser.cc" // lalr1.cc:859
    break;

  case 85:
#line 289 "parser/parser.yy" // lalr1.cc:859
    { if((yystack_[0].value.nameTuplesP)->second == NULL) {(yylhs.value.term) = new Constant((yystack_[0].value.nameTuplesP)->first);} else {(yylhs.value.term) = new Function((yystack_[0].value.nameTuplesP)->first, (yystack_[0].value.nameTuplesP)->second);} delete (yystack_[0].value.nameTuplesP); }
#line 1124 "parser/parser.cc" // lalr1.cc:859
    break;

  case 86:
#line 290 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new Constant((yystack_[0].value.string)); }
#line 1130 "parser/parser.cc" // lalr1.cc:859
    break;

  case 87:
#line 291 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new Constant((yystack_[0].value.string)); }
#line 1136 "parser/parser.cc" // lalr1.cc:859
    break;

  case 88:
#line 292 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new Variable((yystack_[0].value.string)); }
#line 1142 "parser/parser.cc" // lalr1.cc:859
    break;

  case 89:
#line 293 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new AnonymousVariable(); }
#line 1148 "parser/parser.cc" // lalr1.cc:859
    break;

  case 90:
#line 294 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BracketedTerm((yystack_[1].value.term)); }
#line 1154 "parser/parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 295 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new PoolingTerm((yystack_[1].value.terms)); }
#line 1160 "parser/parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 296 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new UnaryTerm((yystack_[0].value.term), NEGATION); }
#line 1166 "parser/parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 297 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new UnaryTerm((yystack_[0].value.term), COMPLEMENT); }
#line 1172 "parser/parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 298 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new UnaryTerm((yystack_[1].value.term), ABSOLUTE); }
#line 1178 "parser/parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 299 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("+"), (yystack_[0].value.term)); }
#line 1184 "parser/parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 300 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("-"), (yystack_[0].value.term)); }
#line 1190 "parser/parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 301 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("*"), (yystack_[0].value.term)); }
#line 1196 "parser/parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 302 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("/"), (yystack_[0].value.term)); }
#line 1202 "parser/parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 303 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("\\"), (yystack_[0].value.term)); }
#line 1208 "parser/parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 304 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("&"), (yystack_[0].value.term)); }
#line 1214 "parser/parser.cc" // lalr1.cc:859
    break;

  case 101:
#line 305 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("?"), (yystack_[0].value.term)); }
#line 1220 "parser/parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 306 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("^"), (yystack_[0].value.term)); }
#line 1226 "parser/parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 307 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string("**"), (yystack_[0].value.term)); }
#line 1232 "parser/parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 308 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.term) = new BinaryTerm((yystack_[2].value.term), new std::string(".."), (yystack_[0].value.term)); }
#line 1238 "parser/parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 311 "parser/parser.yy" // lalr1.cc:859
    { (yylhs.value.terms) = new vector<Term *>(); (yylhs.value.terms)->push_back((yystack_[2].value.term)); (yylhs.value.terms)->push_back((yystack_[0].value.term)); }
#line 1244 "parser/parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 312 "parser/parser.yy" // lalr1.cc:859
    { (yystack_[2].value.terms)->push_back((yystack_[0].value.term)); (yylhs.value.terms)=(yystack_[2].value.terms); }
#line 1250 "parser/parser.cc" // lalr1.cc:859
    break;


#line 1254 "parser/parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char Parser::yypact_ninf_ = -121;

  const signed char Parser::yytable_ninf_ = -71;

  const short int
  Parser::yypact_[] =
  {
    -121,    28,   272,  -121,   161,   187,  -121,  -121,   -20,  -121,
    -121,  -121,  -121,   480,   480,   480,     4,   480,  -121,  -121,
      20,    -3,  -121,   176,    16,    24,  -121,     5,   314,   335,
    -121,  -121,  -121,  -121,  -121,    22,  -121,  -121,   176,    26,
    -121,  -121,  -121,   314,    34,    23,   424,   480,   293,  -121,
    -121,  -121,   508,    36,  -121,    79,  -121,    29,  -121,   389,
     -14,   213,  -121,     0,  -121,  -121,  -121,  -121,  -121,  -121,
     480,  -121,   439,   480,   480,   480,   480,   480,   480,   480,
     480,   480,   480,    48,  -121,  -121,   314,  -121,   239,   480,
     465,   361,   480,    63,  -121,    -4,    64,   550,  -121,  -121,
    -121,     0,    94,   480,  -121,   480,  -121,  -121,    60,  -121,
     550,  -121,    85,  -121,    58,   411,   558,    92,   578,   584,
     397,    55,    55,    92,    92,    92,   176,   157,  -121,   550,
      94,    88,  -121,   -17,   176,   550,    72,   480,   480,  -121,
     480,  -121,     0,    73,  -121,   314,   550,   550,  -121,  -121,
     480,    94,   480,   480,   480,    73,  -121,   465,    94,   480,
    -121,    76,    64,   550,    94,   480,  -121,    73,    64,   529,
     550,  -121,    73,   550,  -121,  -121,   480,    64
  };

  const unsigned char
  Parser::yydefact_[] =
  {
       3,     0,     2,     1,     0,     0,    58,    59,    71,    88,
      87,    86,     5,     0,     0,     0,     0,     0,    89,     4,
       0,    14,    15,    23,     0,     0,    21,    85,     0,     0,
      47,    48,    49,    50,     6,     0,    16,    19,    34,     0,
      18,    66,    67,     0,     0,     0,     0,     0,    85,    92,
      85,    93,     0,     0,    27,     0,    29,    31,    69,     0,
       0,     0,     8,     0,    78,    81,    82,    77,    79,    80,
       0,    13,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,    68,     0,     7,     0,     0,
      41,     0,     0,     0,    72,     0,    74,    83,    94,    70,
      28,     0,    32,     0,    90,     0,    91,     9,     0,    22,
      25,    51,     0,    53,    55,    60,   104,   103,   102,   101,
     100,    95,    96,    97,    98,    99,    24,     0,    17,    36,
      45,     0,    39,    42,    35,    76,     0,     0,     0,    73,
       0,    30,     0,    33,    64,     0,   105,   106,    10,    52,
       0,    56,     0,     0,     0,    46,    38,    41,    43,     0,
      11,     0,    75,    84,     0,     0,    54,    57,    62,    61,
      26,    40,    44,    37,    12,    65,     0,    63
  };

  const signed char
  Parser::yypgoto_[] =
  {
    -121,  -121,  -121,  -121,  -121,     1,    27,  -121,  -121,    38,
    -121,    31,   100,   -77,  -121,   -18,  -121,  -121,  -121,   -13,
    -121,   -88,  -120,   -42,    18,     3,  -121,  -121,     8,   -45,
      -2,  -121
  };

  const short int
  Parser::yydefgoto_[] =
  {
      -1,     1,     2,    19,    20,    35,    36,    21,    22,    23,
      55,    56,    37,    38,   131,   132,    39,    24,   112,   113,
      25,   114,   143,    40,    41,    50,    95,    42,    70,   133,
      97,    60
  };

  const short int
  Parser::yytable_[] =
  {
      28,    96,    43,    43,   136,    27,    45,    27,    27,   -69,
     155,    49,    51,    52,   134,    59,    48,     8,   140,    58,
      26,     8,    46,   158,    61,   105,    53,    86,     3,   106,
      53,   167,    27,    63,    57,   138,    83,   -69,   172,   139,
     -69,   -69,    54,   -69,   -69,    49,    89,    85,    71,   161,
     134,    91,    62,     8,    87,    93,    99,    88,    88,    43,
     144,    72,   108,    90,    27,    74,    58,    92,   110,   102,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   109,    80,    81,    82,    16,    43,   129,   144,   135,
     115,    27,   148,   162,   127,    88,   137,   142,   151,   140,
     145,   146,    74,   147,    58,    27,   160,   168,   164,   144,
     174,     8,     9,    10,    11,   128,   144,   100,   101,    57,
      13,   126,   175,   149,   150,    14,   156,   157,   145,    84,
      15,   177,   141,    27,   154,   115,    17,   166,   163,   171,
       0,    18,   159,     0,     0,    58,     0,     0,   115,   145,
       0,   169,   170,   165,    27,     0,   145,   173,     0,     0,
      85,    27,   145,   135,    29,     0,     0,    27,    30,    31,
      32,    33,    30,    31,    32,    33,     0,     0,     8,     9,
      10,    11,    64,    65,    66,     0,     0,    13,     0,     0,
      29,     0,    14,    34,     0,     0,     0,    15,    30,    31,
      32,    33,     0,    17,     8,     9,    10,    11,    18,     0,
       0,     0,     0,    13,     0,     0,    29,     0,    14,    44,
      67,    68,    69,    15,    30,    31,    32,    33,     0,    17,
       8,     9,    10,    11,    18,     0,     0,     0,     0,    13,
       0,     0,    29,     0,    14,   107,     0,     0,     0,    15,
      30,    31,    32,    33,     0,    17,     8,     9,    10,    11,
      18,     0,     0,     0,     0,    13,     0,     0,     0,     0,
      14,     0,     0,     0,     0,    15,     4,     5,     0,     0,
       0,    17,     0,     0,     0,     0,    18,     6,     7,     8,
       9,    10,    11,    12,     0,     0,     0,   -70,    13,     0,
       0,     0,     0,    14,     0,     0,     0,     0,    15,    16,
       0,     0,     0,     0,    17,     0,     0,     0,     0,    18,
      64,    65,    66,    73,    74,   -70,     0,     0,   -70,   -70,
       0,   -70,   -70,     0,     0,     0,    75,    76,    77,    78,
      79,    80,    81,    82,     0,     0,    30,    31,    32,    33,
       0,     0,     8,     9,    10,    11,     0,     0,    67,    68,
      69,    13,     0,     0,     0,     0,    14,     0,     0,     0,
       0,    15,    30,    31,    32,    33,     0,    17,     8,     9,
      10,    11,    18,     0,     0,     0,     0,    47,     0,     0,
       0,     0,    14,     0,     0,     0,     0,    15,    73,    74,
       0,     0,     0,    17,     0,     0,     0,    74,    18,     0,
       0,    75,    76,    77,    78,    79,    80,    81,    82,     0,
      73,    74,    78,    79,    80,    81,    82,     0,   103,     0,
       0,     0,   104,    75,    76,    77,    78,    79,    80,    81,
      82,     8,     9,    10,    11,     0,   152,     0,     0,     0,
      47,     0,   153,     0,     0,    14,     8,     9,    10,    11,
      15,     0,     0,     0,     0,    47,    17,    94,     0,     0,
      14,    18,     0,     0,     0,    15,     0,   111,     0,     0,
       0,    17,     8,     9,    10,    11,    18,     0,     0,     0,
       0,    47,     0,     0,     0,     0,    14,     8,     9,    10,
      11,    15,     0,     0,     0,   130,    47,    17,     0,     0,
       0,    14,    18,     0,     0,     0,    15,    73,    74,     0,
       0,     0,    17,     0,     0,     0,     0,    18,     0,     0,
      75,    76,    77,    78,    79,    80,    81,    82,    73,    74,
       0,     0,     0,     0,    98,     0,     0,     0,     0,     0,
       0,    75,    76,    77,    78,    79,    80,    81,    82,    73,
      74,     0,     0,     0,   176,     0,     0,     0,    74,     0,
       0,     0,    75,    76,    77,    78,    79,    80,    81,    82,
      75,    76,    77,    78,    79,    80,    81,    82,    74,     0,
       0,     0,     0,     0,    74,     0,     0,     0,     0,     0,
       0,    76,    77,    78,    79,    80,    81,    82,    77,    78,
      79,    80,    81,    82
  };

  const short int
  Parser::yycheck_[] =
  {
       2,    46,     4,     5,    92,     2,     5,     4,     5,     4,
     130,    13,    14,    15,    91,    17,    13,    17,    35,    16,
       2,    17,    42,    40,     4,    39,    26,    29,     0,    43,
      26,   151,    29,    36,    16,    39,    28,    32,   158,    43,
      35,    36,    38,    38,    39,    47,    38,    29,    32,   137,
     127,    43,    32,    17,    32,    32,    53,    35,    35,    61,
     102,    37,    61,    37,    61,    10,    63,    33,    70,    40,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    63,    27,    28,    29,    37,    88,    89,   130,    91,
      92,    88,    32,   138,    86,    35,    33,     3,    40,    35,
     102,   103,    10,   105,   101,   102,    34,   152,    35,   151,
      34,    17,    18,    19,    20,    88,   158,    38,    39,   101,
      26,    83,   164,    38,    39,    31,    38,    39,   130,    29,
      36,   176,   101,   130,   126,   137,    42,   150,   140,   157,
      -1,    47,   134,    -1,    -1,   142,    -1,    -1,   150,   151,
      -1,   153,   154,   145,   151,    -1,   158,   159,    -1,    -1,
     142,   158,   164,   165,     3,    -1,    -1,   164,    11,    12,
      13,    14,    11,    12,    13,    14,    -1,    -1,    17,    18,
      19,    20,     6,     7,     8,    -1,    -1,    26,    -1,    -1,
       3,    -1,    31,    32,    -1,    -1,    -1,    36,    11,    12,
      13,    14,    -1,    42,    17,    18,    19,    20,    47,    -1,
      -1,    -1,    -1,    26,    -1,    -1,     3,    -1,    31,    32,
      44,    45,    46,    36,    11,    12,    13,    14,    -1,    42,
      17,    18,    19,    20,    47,    -1,    -1,    -1,    -1,    26,
      -1,    -1,     3,    -1,    31,    32,    -1,    -1,    -1,    36,
      11,    12,    13,    14,    -1,    42,    17,    18,    19,    20,
      47,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,
      31,    -1,    -1,    -1,    -1,    36,     4,     5,    -1,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    47,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,     4,    26,    -1,
      -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    37,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    47,
       6,     7,     8,     9,    10,    32,    -1,    -1,    35,    36,
      -1,    38,    39,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    11,    12,    13,    14,
      -1,    -1,    17,    18,    19,    20,    -1,    -1,    44,    45,
      46,    26,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    11,    12,    13,    14,    -1,    42,    17,    18,
      19,    20,    47,    -1,    -1,    -1,    -1,    26,    -1,    -1,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    36,     9,    10,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    10,    47,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
       9,    10,    25,    26,    27,    28,    29,    -1,    39,    -1,
      -1,    -1,    43,    22,    23,    24,    25,    26,    27,    28,
      29,    17,    18,    19,    20,    -1,    35,    -1,    -1,    -1,
      26,    -1,    41,    -1,    -1,    31,    17,    18,    19,    20,
      36,    -1,    -1,    -1,    -1,    26,    42,    43,    -1,    -1,
      31,    47,    -1,    -1,    -1,    36,    -1,    38,    -1,    -1,
      -1,    42,    17,    18,    19,    20,    47,    -1,    -1,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    31,    17,    18,    19,
      20,    36,    -1,    -1,    -1,    40,    26,    42,    -1,    -1,
      -1,    31,    47,    -1,    -1,    -1,    36,     9,    10,    -1,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    47,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,     9,    10,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,     9,
      10,    -1,    -1,    -1,    35,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      22,    23,    24,    25,    26,    27,    28,    29,    10,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    24,    25,
      26,    27,    28,    29
  };

  const unsigned char
  Parser::yystos_[] =
  {
       0,    49,    50,     0,     4,     5,    15,    16,    17,    18,
      19,    20,    21,    26,    31,    36,    37,    42,    47,    51,
      52,    55,    56,    57,    65,    68,    72,    73,    78,     3,
      11,    12,    13,    14,    32,    53,    54,    60,    61,    64,
      71,    72,    75,    78,    32,    53,    42,    26,    73,    78,
      73,    78,    78,    26,    38,    58,    59,    72,    73,    78,
      79,     4,    32,    36,     6,     7,     8,    44,    45,    46,
      76,    32,    37,     9,    10,    22,    23,    24,    25,    26,
      27,    28,    29,    76,    60,    72,    78,    32,    35,    76,
      37,    76,    33,    32,    43,    74,    77,    78,    36,    73,
      38,    39,    40,    39,    43,    39,    43,    32,    53,    72,
      78,    38,    66,    67,    69,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    57,    76,    54,    78,
      40,    62,    63,    77,    61,    78,    69,    33,    39,    43,
      35,    59,     3,    70,    71,    78,    78,    78,    32,    38,
      39,    40,    35,    41,    76,    70,    38,    39,    40,    76,
      34,    69,    77,    78,    35,    76,    67,    70,    77,    78,
      78,    63,    70,    78,    34,    71,    35,    77
  };

  const unsigned char
  Parser::yyr1_[] =
  {
       0,    48,    49,    50,    50,    50,    51,    51,    51,    51,
      51,    51,    51,    51,    52,    52,    53,    53,    54,    54,
      54,    55,    55,    56,    56,    56,    56,    57,    57,    58,
      58,    59,    59,    59,    60,    60,    60,    60,    61,    62,
      62,    63,    63,    63,    63,    63,    63,    64,    64,    64,
      64,    65,    65,    66,    66,    67,    67,    67,    68,    68,
      69,    69,    69,    69,    70,    70,    71,    71,    71,    72,
      72,    73,    73,    73,    74,    74,    75,    76,    76,    76,
      76,    76,    76,    77,    77,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    79,    79
  };

  const unsigned char
  Parser::yyr2_[] =
  {
       0,     2,     1,     0,     2,     2,     2,     3,     2,     3,
       4,     5,     6,     2,     1,     1,     1,     3,     1,     1,
       2,     1,     3,     1,     3,     3,     5,     2,     3,     1,
       3,     1,     2,     3,     1,     3,     3,     5,     4,     1,
       3,     0,     1,     2,     3,     1,     2,     1,     1,     1,
       1,     3,     4,     1,     3,     1,     2,     3,     1,     1,
       1,     3,     3,     5,     1,     3,     1,     1,     2,     1,
       2,     1,     3,     4,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"end of file\"", "error", "$undefined", "\"not\"", "\":-\"", "\":~\"",
  "UNEQUAL", "\"<=\"", "\">=\"", "\"..\"", "\"**\"", "\"#count\"",
  "\"#max\"", "\"#min\"", "\"#sum\"", "MINIMIZE", "MAXIMIZE", "ID",
  "VARIABLE", "STRING", "NUMBER", "METASTATEMENT", "'^'", "'?'", "'&'",
  "'+'", "'-'", "'*'", "'/'", "'\\\\'", "UNARYMINUS", "'~'", "'.'", "'['",
  "']'", "','", "'|'", "'{'", "'}'", "';'", "':'", "'@'", "'('", "')'",
  "'='", "'<'", "'>'", "'_'", "$accept", "start", "program", "statement",
  "head", "body", "body_element", "disjunction", "choice",
  "unbounded_choice", "choice_elements", "choice_element", "aggregate",
  "unbounded_aggregate", "aggregate_elements", "aggregate_element",
  "aggregate_function", "optimize", "optimize_elements",
  "optimize_element", "optimize_function", "weight_at_level",
  "naf_literals", "naf_literal", "classical_literal",
  "positive_classical_literal", "termtuples", "builtin_atom", "binop",
  "termtuple", "term", "pooling_term", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  Parser::yyrline_[] =
  {
       0,   139,   139,   142,   143,   144,   154,   155,   156,   157,
     158,   159,   160,   161,   164,   165,   168,   169,   172,   173,
     174,   177,   178,   182,   183,   184,   185,   188,   189,   191,
     192,   195,   196,   197,   200,   201,   202,   203,   206,   209,
     210,   213,   214,   215,   216,   217,   218,   221,   222,   223,
     224,   227,   228,   231,   232,   235,   236,   237,   240,   241,
     244,   245,   246,   247,   250,   251,   254,   255,   256,   259,
     260,   263,   264,   265,   268,   269,   272,   276,   277,   278,
     279,   280,   281,   284,   285,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   311,   312
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    24,     2,
      42,    43,    27,    25,    35,    26,    32,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    40,    39,
      45,    44,    46,    23,    41,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    33,    29,    34,    22,    47,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    37,    36,    38,    31,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    30
    };
    const unsigned int user_token_number_max_ = 277;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 25 "parser/parser.yy" // lalr1.cc:1167
} // parser
#line 1887 "parser/parser.cc" // lalr1.cc:1167
#line 315 "parser/parser.yy" // lalr1.cc:1168


void parser::Parser::error(const parser::Parser::location_type& l, const std::string& m)
{
	driver.error(l, m);
}

// Now that we have the Parser declared, we can declare the Scanner and implement
// the yylex function
#include "scanner.h"
static int yylex(parser::Parser::semantic_type * yylval, parser::Parser::location_type* yylloc, parser::FlexScanner &scanner) {
	return scanner.yylex(yylval, yylloc);
}
