import predictor, clingo

from predictor import Predictor
from clingo_ast_util import ASTVisitor

def main():
    global test_predictor
    test_predictor = Predictor()

    # test_predictor.load_program('programs/compatible/fake/keys.lp')
    test_predictor.load_program('programs/compatible/fake/ranges.lp')
    # test_predictor.load_program('programs/compatible/fake/paper-ex-1.lp')

    rv = RuleVisitor()
    clingo.parse_program(
        # Keys
        # ''':- p(X,Y), p(X,Y).''',
        # ''':- q(M,W,S1), q(M,W1,S2), r(W,M,S3), r(W,M1,S4).''',
        # ''':- q(M,W,S1), q(M,W1,S2), r(S1,S2,S3).''',
        # Ranges
        ''':- p(X), r(X).''',
        # ''':- p(X), s(X).''',
        # ''':- q(X), r(X).''',
        # ''':- p(X), t(Y), X > Y.''',
        # ''':- p(X), X = 1.''',
        # ''':- p(X), X > 2.''',
        # ''':- p(X), X <= 7.''',
        # Paper Example 1
        # '''r(Y) :- p(X), q(X,Y).''',
        lambda stm: rv.visit(stm))
    prediction = test_predictor.predict_rule(rv.rules[0])
    print('Prediction: %s' % prediction)

class RuleVisitor(ASTVisitor):

    def __init__(self):
        self.rules = []
    
    def visit_Rule(self, rule):
        print('Visiting: %s' % rule)
        self.rules.append(rule)
        # test_predictor.predict_rule(rule)

if __name__ == '__main__':
    main()
